<ng-container *ngIf="{
        ghostElements: ghostElements$ | async,
        dayPage: dataPage$ | async,
        categories: categories$ | async,
        competitions: competitions$ | async,
        divisions: divisions$ | async,
        groups: groups$ | async  } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.day.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.day.list.seo.description' | translate }}
      </p>

      <form [formGroup]="formGroup">
        <mat-form-field>
          <mat-label>
            {{ 'admin.day.list.filter.category' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().category"
                                 (resetClick)="categoryChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category">
            <mat-select formControlName="category" (selectionChange)="categoryChange($event.value)">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.day.list.filter.competition' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().competition"
                                 (resetClick)="competitionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.competition"
                            [control]="formGroup.controls.competition">
            <mat-select formControlName="competition" (selectionChange)="competitionChange($event.value)">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.day.list.filter.division' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().division"
                                 (resetClick)="divisionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.division"
                            [control]="formGroup.controls.division">
            <mat-select formControlName="division" (selectionChange)="divisionChange($event.value)">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.day.list.filter.group' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().group"
                                 (resetClick)="groupChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.group"
                            [control]="formGroup.controls.group">
            <mat-select formControlName="group" (selectionChange)="groupChange($event.value)">
              <mat-option *ngFor="let group of vm.groups?.items; trackBy: trackBySlug"
                          [value]="group.slug">
                {{ group.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
      </form>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.dayPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.dayPage?.sort?.field || 'index'"
                 [matSortDirection]="vm.dayPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="index">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.day.list.field.index' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.index }}
              </td>
            </ng-container>

            <ng-container matColumnDef="date">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.day.list.field.date' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.date | date:'shortDate':undefined:'fr-FR' }}
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [queryParams]="{ category: formGroup.value.category, competition: formGroup.value.competition, division: formGroup.value.division, group: formGroup.value.group }"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [queryParams]="{ category: formGroup.value.category, competition: formGroup.value.competition, division: formGroup.value.division, group: formGroup.value.group }"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.dayPage?.count"
                       [pageIndex]="vm.dayPage?.page"
                       [pageSize]="vm.dayPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [queryParams]="{ category: formGroup.value.category, competition: formGroup.value.competition, division: formGroup.value.division, group: formGroup.value.group }"
         [routerLink]="['create']">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>
    </ng-container>
  </app-page-form>
</ng-container>
